diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/onoe-wifi-manager.cc ns-3.31/src/wifi/model/onoe-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/onoe-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/onoe-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,11 +38,12 @@
 struct OnoeWifiRemoteStation : public WifiRemoteStation
 {
   Time m_nextModeUpdate; ///< next mode update
+  bool m_rateBlocked; ///< whether the rate cannot be changed
   uint32_t m_shortRetry; ///< short retry
   uint32_t m_longRetry; ///< long retry
-  uint32_t m_tx_ok; ///< transmit ok
+  uint32_t m_tx_ok; ///< transmit OK
   uint32_t m_tx_err; ///< transmit error
-  uint32_t m_tx_retr; ///< transmit retr
+  uint32_t m_tx_retr; ///< transmit retry
   uint32_t m_tx_upper; ///< transmit upper
   uint8_t m_txrate; ///< transmit rate
 };
@@ -113,6 +114,7 @@
   NS_LOG_FUNCTION (this);
   OnoeWifiRemoteStation *station = new OnoeWifiRemoteStation ();
   station->m_nextModeUpdate = Simulator::Now () + m_updatePeriod;
+  station->m_rateBlocked = false;
   station->m_shortRetry = 0;
   station->m_longRetry = 0;
   station->m_tx_ok = 0;
@@ -133,49 +135,57 @@
 OnoeWifiManager::DoReportRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   station->m_shortRetry++;
+  station->m_rateBlocked = true;  // do not change rate for retransmission
 }
 
 void
 OnoeWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   station->m_longRetry++;
+  station->m_rateBlocked = true;  // do not change rate for retransmission
 }
 
 void
-OnoeWifiManager::DoReportRtsOk (WifiRemoteStation *station, double ctsSnr, WifiMode ctsMode, double rtsSnr)
+OnoeWifiManager::DoReportRtsOk (WifiRemoteStation *st, double ctsSnr, WifiMode ctsMode, double rtsSnr)
 {
-  NS_LOG_FUNCTION (this << station << ctsSnr << ctsMode << rtsSnr);
+  NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode << rtsSnr);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
+  station->m_rateBlocked = true;  // do not change rate
 }
 
 void
-OnoeWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode, double dataSnr)
+OnoeWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                 double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   UpdateRetry (station);
   station->m_tx_ok++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
 }
 
 void
 OnoeWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   UpdateRetry (station);
   station->m_tx_err++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
 }
 
 void
 OnoeWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   UpdateRetry (station);
   station->m_tx_err++;
+  station->m_rateBlocked = false;  // we can change the rate for next packet
 }
 
 void
@@ -191,7 +201,7 @@
 OnoeWifiManager::UpdateMode (OnoeWifiRemoteStation *station)
 {
   NS_LOG_FUNCTION (this << station);
-  if (Simulator::Now () < station->m_nextModeUpdate)
+  if (Simulator::Now () < station->m_nextModeUpdate || station->m_rateBlocked)
     {
       return;
     }
@@ -274,7 +284,7 @@
 OnoeWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   UpdateMode (station);
   NS_ASSERT (station->m_txrate < GetNSupported (station));
   uint8_t rateIndex;
@@ -318,7 +328,6 @@
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiMode mode = GetSupported (station, rateIndex);
@@ -334,11 +343,10 @@
 OnoeWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  OnoeWifiRemoteStation *station = (OnoeWifiRemoteStation *)st;
+  OnoeWifiRemoteStation *station = static_cast<OnoeWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   UpdateMode (station);
@@ -356,10 +364,4 @@
   return rtsTxVector;
 }
 
-bool
-OnoeWifiManager::IsLowLatency (void) const
-{
-  return false;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/onoe-wifi-manager.h ns-3.31/src/wifi/model/onoe-wifi-manager.h
--- ns-3.30.1/src/wifi/model/onoe-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/onoe-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -39,9 +39,9 @@
  * any publication or reference about this algorithm beyond the madwifi
  * source code.
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class OnoeWifiManager : public WifiRemoteStationManager
 {
@@ -65,13 +65,12 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
   /**
    * Update the number of retry (both short and long).
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/originator-block-ack-agreement.h ns-3.31/src/wifi/model/originator-block-ack-agreement.h
--- ns-3.30.1/src/wifi/model/originator-block-ack-agreement.h	2019-09-18 10:36:11.000000000 -0700
+++ ns-3.31/src/wifi/model/originator-block-ack-agreement.h	2020-06-27 17:38:30.000000000 -0700
@@ -32,7 +32,7 @@
 
 /**
  * \ingroup wifi
- * Maintains the state and information about transmitted MPDUs with ack policy block ack
+ * Maintains the state and information about transmitted MPDUs with Ack Policy set to Block Ack
  * for an originator station. The state diagram is as follows:
  *
    \verbatim
@@ -59,6 +59,7 @@
 {
   /// allow BlockAckManager class access
   friend class BlockAckManager;
+  /// allow OriginatorBlockAckWindowTest class access
   friend class ::OriginatorBlockAckWindowTest;
 
 
@@ -81,14 +82,14 @@
   *
   *  ESTABLISHED:
   *    The block ack is active and all packets relative to this agreement are transmitted
-  *    with ack policy set to block ack.
+  *    with Ack Policy set to Block Ack.
   *
   *  NO_REPLY
   *    No reply after an ADDBA request. In this state the originator will send the rest of packets
   *    in queue using normal MPDU.
   *
   *  RESET
-  *    A transient state to mark the agreement for reinitialzation after failed ADDBA request.
+  *    A transient state to mark the agreement for reinitialization after failed ADDBA request.
   *    Since it is a temporary state, it is not included in the state diagram above. In this
   *    state the next transmission will be treated as if the BA agreement is not created yet.
   *
@@ -198,8 +199,6 @@
   /**
    * Advance the transmit window so that the starting sequence number is the
    * nearest unacknowledged MPDU.
-   *
-   * \param newStartingSeq the new starting sequence number
    */
   void AdvanceTxWindow (void);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/parf-wifi-manager.cc ns-3.31/src/wifi/model/parf-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/parf-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/parf-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -179,7 +179,7 @@
 ParfWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  ParfWifiRemoteStation *station = (ParfWifiRemoteStation *)st;
+  ParfWifiRemoteStation *station = static_cast<ParfWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_nAttempt++;
   station->m_nFail++;
@@ -258,11 +258,11 @@
   NS_LOG_FUNCTION (this << station << ctsSnr << ctsMode << rtsSnr);
 }
 
-void ParfWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                      double ackSnr, WifiMode ackMode, double dataSnr)
+void ParfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                      double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  ParfWifiRemoteStation *station = (ParfWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  ParfWifiRemoteStation *station = static_cast<ParfWifiRemoteStation*> (st);
   CheckInit (station);
   station->m_nAttempt++;
   station->m_nSuccess++;
@@ -311,11 +311,10 @@
 ParfWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  ParfWifiRemoteStation *station = (ParfWifiRemoteStation *) st;
+  ParfWifiRemoteStation *station = static_cast<ParfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   CheckInit (station);
@@ -341,13 +340,12 @@
 ParfWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  /// \todo we could/should implement the Arf algorithm for
+  /// \todo we could/should implement the ARF algorithm for
   /// RTS only by picking a single rate within the BasicRateSet.
-  ParfWifiRemoteStation *station = (ParfWifiRemoteStation *) st;
+  ParfWifiRemoteStation *station = static_cast<ParfWifiRemoteStation*> (st);
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -364,10 +362,4 @@
   return rtsTxVector;
 }
 
-bool
-ParfWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/parf-wifi-manager.h ns-3.31/src/wifi/model/parf-wifi-manager.h
--- ns-3.30.1/src/wifi/model/parf-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/parf-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -36,9 +36,9 @@
  * Wireless Networks, Kluwer Academic Publishers, 2007, 13, 737-755
  * http://www.cs.odu.edu/~nadeem/classes/cs795-WNS-S13/papers/enter-006.pdf
  *
- * This RAA does not support HT, VHT nor HE modes and will error
+ * This RAA does not support HT modes and will error
  * exit if the user tries to configure this RAA with a Wi-Fi MAC
- * that has VhtSupported, HtSupported or HeSupported set.
+ * that supports 802.11n or higher.
  */
 class ParfWifiManager : public WifiRemoteStationManager
 {
@@ -65,13 +65,12 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  bool IsLowLatency (void) const;
 
   /** Check for initializations.
    *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/preamble-detection-model.h ns-3.31/src/wifi/model/preamble-detection-model.h
--- ns-3.30.1/src/wifi/model/preamble-detection-model.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/preamble-detection-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -44,7 +44,7 @@
    * This method returns whether the preamble detection was successful.
    *
    * \param rssi the RSSI of the received signal (in Watts).
-   * \param snr the SNR of the received signal.
+   * \param snr the SNR of the received signal in linear scale.
    * \param channelWidth the channel width of the received signal in MHz.
    *
    * \return true if the preamble has been detected,
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/qos-blocked-destinations.h ns-3.31/src/wifi/model/qos-blocked-destinations.h
--- ns-3.30.1/src/wifi/model/qos-blocked-destinations.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/qos-blocked-destinations.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,7 +31,7 @@
 
 /**
  * Keep track of destination address - TID pairs that are waiting
- * for a block ACK response.
+ * for a BlockAck response.
  */
 class QosBlockedDestinations : public SimpleRefCount<QosBlockedDestinations>
 {
@@ -41,26 +41,26 @@
 
   /**
    * Block the given destination address and TID from sending (e.g. pending
-   * block ACK response).
+   * BlockAck response).
    *
-   * \param dest
-   * \param tid
+   * \param dest the destination MAC address
+   * \param tid the TID
    */
   void Block (Mac48Address dest, uint8_t tid);
   /**
-   * Un-block the given destination address and TID (e.g. block ACK
+   * Un-block the given destination address and TID (e.g. BlockAck
    * response received).
    *
-   * \param dest
-   * \param tid
+   * \param dest the destination MAC address
+   * \param tid the TID
    */
   void Unblock (Mac48Address dest, uint8_t tid);
   /**
    * Check if the given destination address and TID are blocked
-   * from sending (e.g. pending block ACK response).
+   * from sending (e.g. pending BlockAck response).
    *
-   * \param dest
-   * \param tid
+   * \param dest the destination MAC address
+   * \param tid the TID
    *
    * \return true if the given destination address and TID are blocked from sending,
    *         false otherwise
@@ -69,7 +69,7 @@
 
 
 private:
-  std::set < std::pair < Mac48Address, uint8_t >> m_blockedQosPackets; ///< blocked QOS packets
+  std::set<std::pair<Mac48Address, uint8_t>> m_blockedQosPackets; ///< blocked QoS packets
 };
 
 } //namespace ns3
